Drop Table If Exists systems;
CREATE TABLE systems ( key varchar(32) primary key Not Null UNIQUE , value varchar(256) Not Null );
COMMENT ON COLUMN systems.key IS 'システム設定キー';
COMMENT ON COLUMN systems.value IS 'システム設定値';
COMMENT ON TABLE systems IS 'システム設定';
CREATE INDEX systems_key ON systems ( key );

Drop Table If Exists currencies;
CREATE TABLE currencies ( id serial primary key Not Null , name varchar(32) Not Null , abbreviation varchar(16) Not Null UNIQUE , created_at timestamp Not Null Default CURRENT_TIMESTAMP , updated_at timestamp Not Null Default CURRENT_TIMESTAMP );
COMMENT ON COLUMN currencies.id IS '通貨ID';
COMMENT ON COLUMN currencies.name IS '通貨名';
COMMENT ON COLUMN currencies.abbreviation IS '通貨略称';
COMMENT ON COLUMN currencies.created_at IS '追加日時';
COMMENT ON COLUMN currencies.updated_at IS '更新日時';
COMMENT ON TABLE currencies IS '通貨';
CREATE INDEX currencies_abbreviation ON currencies ( abbreviation );

Drop Table If Exists pairs;
CREATE TABLE pairs ( id serial primary key Not Null , main_currency_id int Not Null , sub_currency_id int Not Null , name varchar(16) Not Null , created_at timestamp Not Null Default CURRENT_TIMESTAMP , updated_at timestamp Not Null Default CURRENT_TIMESTAMP );
COMMENT ON COLUMN pairs.id IS '通貨ペアID';
COMMENT ON COLUMN pairs.main_currency_id IS 'メイン通貨ID';
COMMENT ON COLUMN pairs.sub_currency_id IS 'サブ通貨ID';
COMMENT ON COLUMN pairs.name IS '通貨ペア名';
COMMENT ON COLUMN pairs.created_at IS '追加日時';
COMMENT ON COLUMN pairs.updated_at IS '更新日時';
COMMENT ON TABLE pairs IS '通貨ペア';
CREATE INDEX pairs_main_currency_id ON pairs ( main_currency_id );
CREATE INDEX pairs_sub_currency_id ON pairs ( sub_currency_id );

Drop Table If Exists exchanges;
CREATE TABLE exchanges ( id serial primary key Not Null , name varchar(32) Not Null );
COMMENT ON COLUMN exchanges.id IS '取引所ID';
COMMENT ON COLUMN exchanges.name IS '取引所名';
COMMENT ON TABLE exchanges IS '取引所';

Drop Table If Exists exchange_pairs;
CREATE TABLE exchange_pairs ( id serial primary key Not Null , exchange_id int Not Null , pair_id int Not Null , system_name varchar(32) Not Null , description text Not Null , unit_min numeric Not Null , unit_step numeric Not Null , aux_unit_min numeric Not Null , aux_unit_step numeric Not Null , is_token smallint Not Null Default 1 , is_valid smallint Not Null Default 1 , created_at timestamp Not Null Default CURRENT_TIMESTAMP , updated_at timestamp Not Null Default CURRENT_TIMESTAMP );
COMMENT ON COLUMN exchange_pairs.id IS '取引所通貨ペアID';
COMMENT ON COLUMN exchange_pairs.exchange_id IS '取引所ID';
COMMENT ON COLUMN exchange_pairs.pair_id IS '通貨ペアID';
COMMENT ON COLUMN exchange_pairs.system_name IS 'システム名(API等システムで使う際の名称)';
COMMENT ON COLUMN exchange_pairs.description IS '詳細';
COMMENT ON COLUMN exchange_pairs.unit_min IS '最低取引量';
COMMENT ON COLUMN exchange_pairs.unit_step IS '最低取引単位';
COMMENT ON COLUMN exchange_pairs.aux_unit_min IS '取引相手最低取引量';
COMMENT ON COLUMN exchange_pairs.aux_unit_step IS '取引相手最低取引単位';
COMMENT ON COLUMN exchange_pairs.is_token IS 'トークン種別(0: 非トークン, 1: トークン)';
COMMENT ON COLUMN exchange_pairs.is_valid IS '有効/無効(0: 無効, 1: 有効)';
COMMENT ON COLUMN exchange_pairs.created_at IS '追加日時';
COMMENT ON COLUMN exchange_pairs.updated_at IS '更新日時';
COMMENT ON TABLE exchange_pairs IS '取引所通貨ペア';
CREATE INDEX exchange_pairs_exchange_id ON exchange_pairs ( exchange_id );
CREATE INDEX exchange_pairs_pair_id ON exchange_pairs ( pair_id );

Drop Table If Exists users;
CREATE TABLE users ( id serial primary key Not Null , loginid varchar(32) Not Null UNIQUE , password varchar(256) Not Null , name varchar(256) Not Null , min numeric Not Null Default 0.02 , is_valid smallint Not Null Default 1 , created_at timestamp Not Null Default CURRENT_TIMESTAMP , updated_at timestamp Not Null Default CURRENT_TIMESTAMP );
COMMENT ON COLUMN users.id IS 'ユーザーID';
COMMENT ON COLUMN users.loginid IS 'ログインID';
COMMENT ON COLUMN users.password IS 'ログインパスワード(ハッシュ値)';
COMMENT ON COLUMN users.name IS 'ユーザー名';
COMMENT ON COLUMN users.min IS '入札最低利幅(0以上)';
COMMENT ON COLUMN users.is_valid IS '有効/無効(0: 無効, 1: 有効)';
COMMENT ON COLUMN users.created_at IS '追加日時';
COMMENT ON COLUMN users.updated_at IS '更新日時';
COMMENT ON TABLE users IS 'ユーザー';
CREATE INDEX users_loginid ON users ( loginid );

Drop Table If Exists user_exchanges;
CREATE TABLE user_exchanges ( id serial primary key Not Null , user_id int Not Null , exchange_id int Not Null , api_key text Not Null , api_secret text Not Null , is_valid smallint Not Null Default 1 , created_at timestamp Not Null Default CURRENT_TIMESTAMP , updated_at timestamp Not Null Default CURRENT_TIMESTAMP );
COMMENT ON COLUMN user_exchanges.id IS 'ユーザー取引所設定ID';
COMMENT ON COLUMN user_exchanges.user_id IS 'ユーザーID';
COMMENT ON COLUMN user_exchanges.exchange_id IS '取引所ID';
COMMENT ON COLUMN user_exchanges.api_key IS 'APIキー';
COMMENT ON COLUMN user_exchanges.api_secret IS 'APIシークレット';
COMMENT ON COLUMN user_exchanges.is_valid IS '有効/無効(0: 無効, 1: 有効)';
COMMENT ON COLUMN user_exchanges.created_at IS '追加日時';
COMMENT ON COLUMN user_exchanges.updated_at IS '更新日時';
COMMENT ON TABLE user_exchanges IS 'ユーザー取引所設定';
CREATE INDEX user_exchanges_user_id ON user_exchanges ( user_id );
CREATE INDEX user_exchanges_exchange_id ON user_exchanges ( exchange_id );

Drop Table If Exists user_exchange_pairs;
CREATE TABLE user_exchange_pairs ( id serial primary key Not Null , user_id int Not Null , exchange_id int Not Null , pair_id int Not Null , min numeric Not Null Default 0 , max numeric Not Null Default 0 , is_ask_valid smallint Not Null Default 0 , is_bid_valid smallint Not Null Default 0 , is_valid smallint Not Null Default 1 , created_at timestamp Not Null Default CURRENT_TIMESTAMP , updated_at timestamp Not Null Default CURRENT_TIMESTAMP );
COMMENT ON COLUMN user_exchange_pairs.id IS 'ユーザー取引通貨設定ID';
COMMENT ON COLUMN user_exchange_pairs.user_id IS 'ユーザーID';
COMMENT ON COLUMN user_exchange_pairs.exchange_id IS '取引所ID';
COMMENT ON COLUMN user_exchange_pairs.pair_id IS '通貨ペアID';
COMMENT ON COLUMN user_exchange_pairs.min IS '最低取引量(0: 設定なし, 0より大きな数値: 有効設定)';
COMMENT ON COLUMN user_exchange_pairs.max IS '最大取引量(0: 設定なし, 0より大きな数値: 有効設定)';
COMMENT ON COLUMN user_exchange_pairs.is_ask_valid IS '買いの有効/無効(0: 無効, 1: 有効)';
COMMENT ON COLUMN user_exchange_pairs.is_bid_valid IS '売りの有効/無効(0: 無効, 1: 有効)';
COMMENT ON COLUMN user_exchange_pairs.is_valid IS '有効/無効(0: 無効, 1: 有効)';
COMMENT ON COLUMN user_exchange_pairs.created_at IS '追加日時';
COMMENT ON COLUMN user_exchange_pairs.updated_at IS '更新日時';
COMMENT ON TABLE user_exchange_pairs IS 'ユーザー取引通貨設定';
CREATE INDEX user_exchange_pairs_user_id ON user_exchange_pairs ( user_id );
CREATE INDEX user_exchange_pairs_exchange_id ON user_exchange_pairs ( exchange_id );
CREATE INDEX user_exchange_pairs_pair_id ON user_exchange_pairs ( pair_id );

Drop Table If Exists orders;
CREATE TABLE orders ( id bigserial primary key Not Null , user_id int Not Null , status int Not Null , is_valid smallint Not Null Default 1 , created_at timestamp Not Null Default CURRENT_TIMESTAMP , updated_at timestamp Not Null Default CURRENT_TIMESTAMP );
COMMENT ON COLUMN orders.id IS '注文ID';
COMMENT ON COLUMN orders.user_id IS 'ユーザーID';
COMMENT ON COLUMN orders.status IS '状態(マスタは別途管理)';
COMMENT ON COLUMN orders.is_valid IS '有効/無効(0: 無効, 1: 有効)';
COMMENT ON COLUMN orders.created_at IS '追加日時';
COMMENT ON COLUMN orders.updated_at IS '更新日時';
COMMENT ON TABLE orders IS '注文';
CREATE INDEX orders_user_id ON orders ( user_id );
CREATE INDEX orders_status ON orders ( status );

Drop Table If Exists positions;
CREATE TABLE positions ( id bigserial primary key Not Null , user_id int Not Null , status int Not Null , is_valid smallint Not Null Default 1 , created_at timestamp Not Null Default CURRENT_TIMESTAMP , updated_at timestamp Not Null Default CURRENT_TIMESTAMP );
COMMENT ON COLUMN positions.id IS '保持通貨ID';
COMMENT ON COLUMN positions.user_id IS 'ユーザーID';
COMMENT ON COLUMN positions.status IS '状態(マスタは別途管理)';
COMMENT ON COLUMN positions.is_valid IS '有効/無効(0: 無効, 1: 有効)';
COMMENT ON COLUMN positions.created_at IS '追加日時';
COMMENT ON COLUMN positions.updated_at IS '更新日時';
COMMENT ON TABLE positions IS '保持通貨';
CREATE INDEX positions_user_id ON positions ( user_id );
CREATE INDEX positions_status ON positions ( status );

Drop Table If Exists quotations;
CREATE TABLE quotations ( id bigserial primary key Not Null , exchange_id int Not Null , pair_id int Not Null , type int Not Null , price numeric Not Null , unit numeric Not Null , is_used smallint Not Null Default 0 , created_at timestamp Not Null Default CURRENT_TIMESTAMP , updated_at timestamp Not Null Default CURRENT_TIMESTAMP );
COMMENT ON COLUMN quotations.id IS '気配ID';
COMMENT ON COLUMN quotations.exchange_id IS '取引所ID';
COMMENT ON COLUMN quotations.pair_id IS '通貨ペアID';
COMMENT ON COLUMN quotations.type IS '種別(種別(1: 売り(ask), 2: 買い(bid)))';
COMMENT ON COLUMN quotations.price IS '価格';
COMMENT ON COLUMN quotations.unit IS '量';
COMMENT ON COLUMN quotations.is_used IS '使用済み(0: 未使用, 1: 使用済み)';
COMMENT ON COLUMN quotations.created_at IS '追加日時';
COMMENT ON COLUMN quotations.updated_at IS '更新日時';
COMMENT ON TABLE quotations IS '気配';
CREATE INDEX quotations_exchange_id ON quotations ( exchange_id );
CREATE INDEX quotations_pair_id ON quotations ( pair_id );
CREATE INDEX quotations_type ON quotations ( type );
CREATE INDEX quotations_price ON quotations ( price );
